
library(inline)
library(Rcpp)
Rcpp::sourceCpp("EM.cpp")
SAME=function(Y,MAX,seed=123,rep=3){
  library(cidr)
  LL=NULL
  clusterresults=NULL
  ensemblecluster=NULL
  mm_k=NULL

  AIC=NULL
  BIC=NULL
  numclus=NULL
  I=NULL
  N=dim(Y)[1] #number of subjects
  H=dim(Y)[2] #number of clustering methods
  K=apply(Y,2,max,na.rm=TRUE) #number of clusters for each of the H clustering methods
  set.seed(seed)
  
  for(M in 2:MAX){
    
    for (r in 1:rep){
      assign(paste('CR',r,sep=''), EM_algorithm(Y,M))
      if(r==1){ CR = CR1}
      else{ 
        if(get(paste('CR',r,sep=''))$`Log Likelihood`>CR$`Log Likelihood`){
          CR=get(paste('CR',r,sep=''))
        }
      }
    }
    
    #if(CR$`Number of parameter`>N){break}
    i=1 
    if(length(LL)>0 && (CR$`Number of clusters` !=M || CR$`Log Likelihood`<LL[length(LL)])){ 
      
      repeat{
        CR=EM_algorithm(Y,M)
        i=i+1
        if((CR$`Number of clusters`==M && CR$`Log Likelihood`>LL[length(LL)]) || i>3){break}
      }
    }
    #number of clusters
    I=c(I,i)
    if(length(LL)>0 && (CR$`Number of clusters`!=M || CR$`Log Likelihood`< LL[length(LL)])){break}
    numclus=c(numclus,CR$`Number of clusters`)
    clusterresults=c(clusterresults,list(CR$`Cluster results`)) #clusters
    #ensemblecluster=c(ensemblecluster,list(table(cluster))) #table of how many are in clusters

    AIC=c(AIC,CR$AIC)
    LL=c(LL,CR$`Log Likelihood`)
    BIC=c(BIC,CR$BIC)
    final_k_AIC=numclus[which(AIC==min(AIC))]
    final_k_BIC=numclus[which(BIC==min(BIC))]
    
    
  }


  BICcluster=clusterresults[[which(BIC==min(BIC))]]
  AICcluster=clusterresults[[which(AIC==min(AIC))]]
  result=list( BICcluster=BICcluster, AICcluster=AICcluster, final_k_BIC=final_k_BIC, final_k_AIC=final_k_AIC)
  return(result)
}


